
/*
    cc -g -DAskme_with_maiN -DAskme_with_regeX -o saskme askme.c
*/

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#ifdef Askme_with_regeX
#include <regex.h>
#endif /* Askme_with_regeX */


#define TSOB_FELD(typ,anz) (typ *) malloc((anz)*sizeof(typ));


#ifndef Askme_sfile_externaL

char *Sfile_fgets(line,maxl,fp)
char *line;
int maxl;
FILE *fp;
{
int l;
char *ret;
 ret= fgets(line,maxl,fp);
 if(ret==NULL) return(NULL);
 l= strlen(line);
 if(l>0) if(line[l-1]=='\r') line[--l]= 0;
 if(l>0) if(line[l-1]=='\n') line[--l]= 0;
 if(l>0) if(line[l-1]=='\r') line[--l]= 0;
 return(ret);
}

#endif /*  Askme_sfile_externaL */


#include "askme.h"



int Askme_new(askme,progname,filename,flag)
struct AskmE **askme;
char *progname;
char *filename;
int flag;
{
 struct AskmE *m;
 
 *askme= m= TSOB_FELD(struct AskmE,1);
 if(m==NULL)
   return(-1);
 strcpy(m->progname,progname);
 strcpy(m->filename,filename);
 m->num_level_info= 0;
 m->count_level_info= 0;
 m->level_info= NULL;
 m->num_sublevels= 0;
 m->sublevels= NULL;
 m->num_volumes= 0;
 m->files_in_volume= NULL;
 m->count_in_volume= NULL;
 m->volume_info= NULL;
 m->volumes= NULL;
 m->sub= 1;
 m->suball= 0;
 m->levelall= 0;
 m->nolevel= 0;
 m->dialog= 0;
 m->fully_compatible= 1;
 m->found= 0;
 m->search_failed= 0;
 return(1);
}


int Askme_destroy(askme,flag)
struct AskmE **askme;
int flag;
{
 int i,j;
 struct AskmE *m;

 m= *askme;
 if(m==NULL)
   return(0);
 if(m->level_info!=NULL) {
   for(i=0;i<m->count_level_info;i++) {
     if(m->level_info[i]!=NULL)
       free(m->level_info[i]);
     m->level_info[i]= NULL;
   }
   free((char *) m->level_info);
 }
 if(m->sublevels!=NULL)
   for(i=0;i<m->num_sublevels;i++)
     Askme_destroy(&(m->sublevels[i]),0);
 if(m->volumes!=NULL) {
   for(i=0;i<m->num_volumes;i++) {
     if(m->volumes[i]==NULL)
   continue;
     for(j=0;j<m->files_in_volume[i];j++) 
       if(m->volumes[i][j]!=NULL) {
         free(m->volumes[i][j]);
         m->volumes[i][j]= NULL;
       }
     free((char *) m->volumes[i]);
     m->volumes[i]= NULL;
   }
   free((char *) m->volumes);
   m->volumes= NULL;
 }
 if(m->files_in_volume!=NULL)
   free((char *) m->files_in_volume);
 if(m->count_in_volume!=NULL)
   free((char *) m->count_in_volume);
 if(m->volume_info!=NULL) {
   for(i=0;i<m->num_volumes;i++) {
     if(m->volume_info[i]!=NULL)
       free(m->volume_info[i]);
     m->volume_info[i]= NULL;
   }
   free((char *) m->volume_info);
 }
 m->files_in_volume= NULL;
 free((char *) m);
 *askme= NULL;
 return(1);
}


int Askme_count_volumes_and_subs(askme,flag)
struct AskmE *askme;
int flag;
{
 int ret,maxlev,maxvol;
 FILE *fp= NULL;
 char line[2*4096],*cpt;

 fp= fopen(askme->filename,"r");
 if(fp==NULL)
   {ret= 0; goto ex;}
 while(Sfile_fgets(line,sizeof(line)-1,fp)!=NULL) {
   if(strncmp(line,"for lev in ",11)==0) {
     maxlev= -1;
     sscanf(line+11,"%ld",&maxlev);
     if(maxlev>=0)
       askme->num_sublevels= maxlev+1;
   }
   if(strncmp(line,"  for cd in ",12)==0) {
     cpt= strrchr(line,' ');
     maxvol= -1;
     sscanf(cpt+1,"%ld",&maxvol);
     if(maxvol>0)
       askme->num_volumes= maxvol;
   }
 }
 ret= 1;
ex:;
 if(fp!=NULL)
   fclose(fp);
 return(ret);
}


int Askme__bourne_to_reg(bourne_expr,reg_expr,flag)
char bourne_expr[],reg_expr[];
int flag;
/* reg_expr should be twice as large as bourne_expr ( + 2 to be exact) */
{
 char *wpt,*lpt;
 int backslash= 0;

 wpt= reg_expr;
 lpt= bourne_expr;

 *(wpt++)= '^';

 while(*lpt!=0){
  if(!backslash){
    switch(*lpt){
    case '?':
      *(wpt++)= '.';
    break;case '*':
      *(wpt++)= '.';
      *(wpt++)= '*';
    break;case '.':
      *(wpt++)= '\\';
      *(wpt++)= '.';
    break;case '+':
      *(wpt++)= '\\';
      *(wpt++)= '+';
    break;case '!':
      *(wpt++)= '^';
    break;case '^':
      *(wpt++)= '\\';
      *(wpt++)= '^';
    break;case '$':
      *(wpt++)= '\\';
      *(wpt++)= '$';
    break;case '\\':
      backslash= 1;
      *(wpt++)= '\\';
    break;default:
      *(wpt++)= *lpt;
    }
  } else {
    backslash= 0;
    *(wpt++)= *lpt;
  }
  lpt++;
 }
 *(wpt++)= '$';
 *wpt= 0;
 return(1);
}


int Askme_check_volno(askme,line,volno,flag)
struct AskmE *askme;
char *line;
int *volno;
int flag;
/* return: <=0 = error , 1=is list_start , 2= is something else */
{
 char *cpt;

 if(strncmp(line,"cd_liste_",9)!=0) 
   return(2);
 for(cpt=line+9;(*cpt)!='(' && (*cpt)!='_' && (*cpt)!=0;cpt++);
 *cpt= 0;
 *volno= -1;
 sscanf(line+9,"%ld",volno);
 if(*volno<=0) {
   fprintf(stderr,"Does not look like an ASKME file : %s\n",askme->filename);
   return(0);
 }
 return(1);
}


int Askme_read_items(askme,flag)
struct AskmE *askme;
int flag;
/*
 bit0= count items , do not store them in **askme->volumes
*/
{
 int ret,list_open= 0,volno,l,info_open= 0;
 FILE *fp= NULL;
 char line[2*4096],*cpt,*apt;

 fp= fopen(askme->filename,"r");
 if(fp==NULL)
   {ret= 0; goto ex;}
 while(Sfile_fgets(line,sizeof(line)-1,fp)!=NULL) {
   if(list_open==0 && info_open==0) {
     ret= Askme_check_volno(askme,line,&volno,0);
     if(ret<=0)
       goto ex;
     if(ret==1) {
       if(volno>askme->num_volumes)
         goto false_format;
       list_open= 1;
     } else if(!(flag&1) && strncmp(line,"  echo '########## part ",24)==0) {
       volno= -1;
       sscanf(line+24,"%ld",&volno);
       if(volno<1||volno>askme->num_volumes)
         goto false_format;
       cpt= strchr(line+24,'(');
       if(cpt==NULL)
         goto false_format;
       l= strlen(cpt);
       if(l<2||cpt[l-1]!='\''||cpt[l-2]!=')')
         goto false_format;
       cpt[l-2]= 0;
       askme->volume_info[volno-1]= TSOB_FELD(char,strlen(cpt+1)+1);
       if(askme->volume_info[volno-1]==NULL)
         {ret= -1; goto ex;}
       strcpy(askme->volume_info[volno-1],cpt+1);
     } else if(strncmp(line,"  echo 'cd_backup_planer",24)==0 &&
               strcmp(line+strlen(line)-19,"information script'")==0) {
       info_open= 1;
       goto handle_level_info;
     }
   } else if (list_open==1) {
     if(strcmp(line,"cat  <<+")!=0 && strcmp(line,"cat  <<'+'")!=0) {
false_format:;
       fprintf(stderr,"Does not look like an ASKME file : %s\n",
               askme->filename); 
       ret= 0; goto ex;
     }
     list_open= 2;
   } else if(list_open==2) {
     if(strcmp(line,"+")==0)
       list_open= 0;
     else {
       if(flag&1) {
         askme->files_in_volume[volno-1]++;
       } else {
         cpt= TSOB_FELD(char,strlen(line)+1);
         if(cpt==NULL)
           {ret= -1; goto ex;}
         strcpy(cpt,line);
         if(askme->count_in_volume[volno-1]>=askme->files_in_volume[volno-1]) 
           goto false_format;
         askme->volumes[volno-1][askme->count_in_volume[volno-1]]= cpt;
         askme->count_in_volume[volno-1]++;
       }
     }
   } else if(info_open) {
     if(line[0]==0)
 continue;
     if(strcmp(line,"fi")==0) {
       info_open= 0;
 continue;
     }
handle_level_info:;
     if(flag&1) {
       askme->num_level_info++;
     } else {
       if(askme->count_level_info>=askme->num_level_info)
         goto false_format;
       cpt= TSOB_FELD(char,strlen(line)+1);
       if(cpt==NULL)
         {ret= -1; goto ex;}
       apt= strchr(line,'\'');
       if(apt==NULL)
 continue;
       apt++;
       strcpy(cpt,apt);
       apt= strrchr(cpt,'\'');
       if(apt!=NULL)
         (*apt)= 0;
       askme->level_info[askme->count_level_info]= cpt;
       askme->count_level_info++;
     }
   }
 }

 ret= 1;
ex:;
 if(fp!=NULL)
   fclose(fp);
 return(ret);
}


int Askme_count_items(askme,flag)
struct AskmE *askme;
int flag;
{
 int ret;

 ret= Askme_read_items(askme,1);
 return(ret);
}


int Askme_read_level(askme,flag)
struct AskmE *askme;
int flag;
{
 int ret,i,j;

 if(askme->volumes!=NULL)
   return(-2);                                   /* programming error caught */
 ret= Askme_count_volumes_and_subs(askme,0);
 if(ret<=0)
   return(ret);
 if(askme->num_volumes<=0)
   return(2);
 askme->files_in_volume= TSOB_FELD(int,askme->num_volumes);
 askme->count_in_volume= TSOB_FELD(int,askme->num_volumes);
 askme->volume_info= TSOB_FELD(char *,askme->num_volumes);
 askme->volumes= TSOB_FELD(char **,askme->num_volumes);
 if(askme->count_in_volume==NULL || askme->files_in_volume==NULL ||
    askme->volume_info==NULL || askme->volumes==NULL)
   return(-1);
 for(i=0;i<askme->num_volumes;i++) {
   askme->files_in_volume[i]= 0;
   askme->count_in_volume[i]= 0;
   askme->volume_info[i]= NULL;
   askme->volumes[i]= NULL;
 }
 ret= Askme_count_items(askme,0);
 if(ret<=0)
   return(ret);
 if(askme->num_level_info>=0) {
   askme->level_info= TSOB_FELD(char *,askme->num_level_info);
   if(askme->level_info==NULL)
     return(-1);
   for(i=0;i<askme->num_level_info;i++) 
     askme->level_info[i]= NULL;
 }
 for(i=0;i<askme->num_volumes;i++) {
   if(askme->files_in_volume[i]<=0)
 continue;
   askme->volumes[i]= TSOB_FELD(char *,askme->files_in_volume[i]);
   if(askme->volumes[i]==NULL)
     return(-1);
   for(j=0;j<askme->files_in_volume[i];j++)
     askme->volumes[i][j]= NULL;
 }  
 ret= Askme_read_items(askme,0);
 if(ret<=0)
   return(ret);
 return(1);
}


int Askme_read_all(askme,flag)
struct AskmE *askme;
int flag;
{
 int ret,i;
 char levelname[4096],*cpt;

 ret= Askme_read_level(askme,0);
 if(ret<=0)
   return(ret);
 if(askme->num_sublevels>0) {
   askme->sublevels= TSOB_FELD(struct AskmE *,askme->num_sublevels);
   if(askme->sublevels==NULL)
     return(-1);
   for(i=0;i<askme->num_sublevels;i++)
     askme->sublevels[i]= NULL;
   for(i=0;i<askme->num_sublevels;i++) {
     strcpy(levelname,askme->filename);
     cpt= strrchr(levelname,'/');
     if(cpt!=NULL)
       *(cpt+1)= 0;
     else
       levelname[0]= 0;
     sprintf(levelname+strlen(levelname),"ASKME_level_%ld",i);
     ret= Askme_new(&(askme->sublevels[i]),askme->progname,levelname,0);
     if(ret<=0)
       return(ret);
     ret= Askme_read_level(askme->sublevels[i],0);
     if(ret<=0)
       return(ret); 
   }
 }
 return(1);
}


int Askme_found(askme,level,volume,item,adr,flag)
struct AskmE *askme;
int level,volume,item;
char *adr;
int flag;
/*
 bit0= do not report level
*/
{
 if(level>=0 && !(flag&1))
   fprintf(stdout,"+++ on backup level %ld\n",level);
 fprintf(stdout,"%ld   %s   %s\n",volume+1,askme->volumes[volume][item],adr);
 askme->found++;
 return(1);
}


int Askme_search_file(askme,adr,level,flag)
struct AskmE *askme;
char *adr;
int level;
int flag;
{
 int ret,i,j,l,found= 0;
#ifdef Askme_with_regeX
 regex_t re;
 regmatch_t match[1];
 char reg_expr[2*4096];
#endif /* Askme_with_regeX */

 if(askme->search_mode==2 || askme->search_mode==3) {
#ifdef Askme_with_regeX
   if(askme->search_mode==3) {
     if(strlen(adr)*2+2>sizeof(reg_expr)) {
       strcpy(reg_expr,"((expression too long))");
       goto cannot_compile;
     }
     Askme__bourne_to_reg(adr,reg_expr,0);
   } else
     strcpy(reg_expr,adr);
   if(regcomp(&re,reg_expr,0)!=0) {
cannot_compile:;
     fprintf(stderr,"%s : cannot compile regular expression : %s\n",
             askme->progname,reg_expr);
     return(0);
   }
#else /* Askme_with_regeX */
   fprintf(stderr,"%s : regular expressions not implemented\n",askme->progname);
   return(-2);
#endif /* ! Askme_with_regeX */
 }

 for(i=0;i<askme->num_volumes;i++) {
   if(askme->volumes[i]==NULL)
 continue;
   for(j=0;j<askme->count_in_volume[i];j++) {
     if(askme->volumes[i][j]==NULL)
   continue;
     l= strlen(askme->volumes[i][j]);
     if(askme->search_mode==0) {
       if(strncmp(adr,askme->volumes[i][j],l)==0)
         if(adr[l]=='/'||adr[l]==0) {
           Askme_found(askme,level,i,j,adr,found>0);
           found= 1;
   break;
         }
       if(askme->sub==0)
   continue;
       l= strlen(adr);
       if(strncmp(askme->volumes[i][j],adr,l)==0)
         if(askme->volumes[i][j][l]=='/'||askme->volumes[i][j][l]==0) {
           Askme_found(askme,level,i,j,adr,found>0);
           found= 1;
           if(askme->suball==0)
   break;
         }
     } else if(askme->search_mode==1) {
       if(strstr(askme->volumes[i][j],adr)!=NULL) {
         Askme_found(askme,level,i,j,adr,found>0);
         found= 1;
       }
     } else if(askme->search_mode==2 || askme->search_mode==3) {
#ifdef Askme_with_regeX
       if(regexec(&re,askme->volumes[i][j],1,match,0)==0) {
         Askme_found(askme,level,i,j,adr,found>0);
         found= 1;
       }
#else /* Askme_with_regeX */
       ;
#endif /* ! Askme_with_regeX */
     }
   }
 }
 if(found && askme->levelall==0)
   return(found);
 if(askme->nolevel)
   return(found);
 for(i= askme->num_sublevels-1;i>=0;i--) {
   if(askme->sublevels[i]==NULL)
 continue;
   askme->sublevels[i]->nolevel= 1;
   ret= Askme_search_file(askme->sublevels[i],adr,i,0);
   if(ret<0)
     return(ret);
   found|= ret;
   askme->found+= askme->sublevels[i]->found;
   if(found && askme->levelall==0)
 break;
 }
 if(found==0)
   askme->search_failed++;
 return(found);
}


int Askme_list(askme,volume,flag)
struct AskmE *askme;
int volume;
int flag;
{
 int i,j;

 for(i=0;i<askme->num_volumes;i++) {
   if(volume>0 && i!=volume-1)
 continue;
   fprintf(stdout,"########## part %ld  (%s)\n",i+1,askme->volume_info[i]);
   for(j=0;j<askme->count_in_volume[i];j++) {
     if(askme->volumes[i][j]!=NULL)
       fprintf(stdout,"%s\n",askme->volumes[i][j]);
   }
 }
 return(1);
}


int Askme_id(askme,flag)
struct AskmE *askme;
int flag;
{
 int i;

 for(i=0;i<askme->num_level_info;i++) {
   if(askme->level_info[i]==NULL)
 continue;
   fprintf(stdout,"%s\n",askme->level_info[i]);
   if(i==0)
     fprintf(stdout,"\n");
 }
 fprintf(stdout,"\n");
 return(1);
}


int Askme_help(askme,flag)
struct AskmE *askme;
int flag;
{
 static char text[][80]={
"This program reads an ASKME script created by scdbackup. Also it reads",
"possible older level files ASKME_level_# from the same directory.",
"It then may search for file addresses or report other information like",
"the ASKME scripts do by themselves.",
"The difference is that this program runs much faster than the scripts",
"and that it has a dialog mode which avoids re-reading of the scripts.",
"Several search modes allow to look for partially known list items.",
"This program is a binary and will run only on the system it was compiled for.",
"",
"options :",
"  -help       prints this text",
"  -hilfe      gibt diesen Text in deutscher Sprache aus",
"              (prints this text in german language)",
"  -id         prints a message about this backup",
"  -count      prints the number of parts",
"  -list       prints the parts and their items",
"  -list:#     prints a single part (e.g. -list:3)",
"  -levelall   lookup all levels (else: show only youngest match)",
"  -nolevel    do not look in older levels",
"  -level_reset  revoke -levelall or -nolevel",
"  -suball     lookup all sub items and levels (else: show one per part)",
"  -fast       do not look for sub items",
"  -sub_reset  revoke -suball or -fast",
"  -search_fgrep  search filename as arbitrary piece of item",
#ifdef Askme_with_regeX
"  -search_grep   search with filename as regular expression     (X.*Y\\.jpg$)",
"  -search_shpat  search with filename as shell parser pattern     (*X*Y.jpg)",
"                 (but without the special handling of '/' and '.')",
#endif /* Askme_with_regeX */
"  -search_reset  compare start pieces of filename and items",
"  -dialog     after all arguments are processed, enter dialog mode.",
"              In this mode you may enter filenames or any of the options",
"              described here. One per line.",
"  -dialog_reset  revoke -dialog (works only if given as argument)",
"  -prog:text  Use text as this program's name in subsequent messages",
"  -prog_help:text  Use text as this program's name and perform -help",
"  -prog_hilfe:text Use text as this program's name and perform -hilfe",
"  -end        end program immediately",
"filenames (respectively directories) are looked up in the parts' item lists.",
"If the filename or a directory above is found then the part number, the item",
"and the filename are printed.",
"If filename is a directory and an item below this address is found, then the",
"action depends on -suball and -fast.",
"If nothing is found then usually the older levels are searched. This behavior",
"depends on -levelall and -nolevel .",
"",
"The options -help, -hilfe, -prog_help, -prog_hilfe are recognized even if",
"given as first argument instead of a sourcefile's name.",
"@ENDE_OF_HELPTEXT_(HOPEFULLY_UNIQUELY_SILLY_TEXT)@"
 };
 char line[4096];
 int i;

 if(askme->level_info!=NULL) 
   Askme_id(askme,0);
 fprintf(stdout,"\n"); 
 fprintf(stdout,"usage: %s sourcefile [options|filenames]\n",askme->progname); 
 fprintf(stdout,"\n"); 
 for(i=0;
     strcmp(text[i],"@ENDE_OF_HELPTEXT_(HOPEFULLY_UNIQUELY_SILLY_TEXT)@")!=0;
     i++)
   fprintf(stdout,"%s\n",text[i]);
 fprintf(stdout,"\n"); 
 fprintf(stdout,"Examples (search acorn.jpg on all backup levels) :\n");
 fprintf(stdout,"  %s /cdrom/ASKME -levelall /home/pictures/trees/acorn.jpg\n",
                askme->progname);
 fprintf(stdout,"  %s /cdrom/ASKME -levelall -search_shpat '*trees/acorn*'\n",
                askme->progname);
 return(1);
}


int Askme_hilfe(askme,flag)
struct AskmE *askme;
int flag;
{
 static char text[][80]={
"Dieses Programm liest ein ASKME-Skript, das von scdbackup erzeugt wurde.",
"Ausserdem liest es ggf. die Skripte der aelteren Level aus dem selben",
"Directory. Es kann dann nach Fileadressen suchen oder andere Informationen",
"ausgeben, wie es auch die ASKME-Skripte tun.",
"Der Unterschied ist, dass dieses Programm viel schneller als die Skripte",
"sucht und dass es einen Dialogmodus hat, der wiederholtes Einlesen der",
"Skripte vermeidet. Das Programm erlaubt auch die Suche nach Namensteilen.",
"Dieses Programm ist binaer und laeuft nur auf den Systemen fuer die es",
"compiliert wurde.",
"",
"Optionen :",
"  -hilfe      gibt diesen Text aus",
"  -help       prints this text in english language",
"              (gibt diesen Text in englischer Sprache aus)",
"  -id         gibt eine Meldung ueber diesen Backup aus",
"  -count      gibt die Zahl der Teile aus",
"  -list       gibt die Teile und ihre Filelisten aus",
"  -list:#     gibt nur einen einzelnen Teil aus (zB. -list:4)",
"  -levelall   alle Level zeigen (sonst: nur den juengsten Fund)",
"  -nolevel    keine aelteren Levels durchsuchen", 
"  -level_reset  Widerruf von -levelall oder -nolevel",
"  -suball     alle Unteradressen zeigen (sonst: eine pro Stueck)",
"  -fast       nicht nach Unteradressen suchen",
"  -sub_reset  Widerruf von -suball oder -fast  ",
"  -search_fgrep  suche Filename als Teiltext in der Backupliste",
#ifdef Askme_with_regeX
"  -search_grep   suche mit Filename als regular expression  (X.*Y\\.jpg$)",
"  -search_shpat  suche mit Filename als Shellparserausdruck   (*X*Y.jpg)",
"                 (aber ohne die besondere Behandlung von '/' und '.')",
#endif /* Askme_with_regeX */
"  -search_reset  vergleiche Anfangsstuecke von Filename und Listeneintag",
"  -dialog     nachdem alle Argumente verarbeitet sind, geht das Programm in",
"              den Dialogmodus. Man kann dann Filenamen oder die hier",
"              beschriebenen Optionen eingeben (nur eine pro Zeile).",
"  -dialog_reset  Widerruf von -dialog (wirkt nur als Argument)",
"  -prog:text  text als Programmname in allen weiteren Meldungen verwenden.",
"  -prog_help:text  text als Programmname verwenden und -help aufrufen",
"  -prog_help:text  text als Programmname verwenden und -hilfe aufrufen",
"  -end        Programm sofort beenden",
"Filenamen (bzw. Directories) werden in den Filelisten der Teile gesucht.",
"Wenn ein Filename oder ein darueberliegendes Directory gefunden  wird, dann",
"werden die Stuecknummer, die gefundene Adresse und der Filename ausgegeben.",
"Wenn der Filename ein Directory bezeichnet und wenn eine Adresse unter",
"diesem Directory in der Liste gefunden wird, dann haengt die Reaktion von",
"-suball und -fast ab.",
"Wird nichts gefunden, dann werden normalerweise auch eventuell vorhandene",
"aeltere Levels durchsucht. Das haengt von -levelall und -nolevel ab.",
"",
"Die Optionen -help, -hilfe, -prog_help, -prog_hilfe werden auch dann erkannt",
"wenn sie anstelle des Quellfilenamens als erstes Argument angegeben werden.",
"@ENDE_OF_HELPTEXT_(HOPEFULLY_UNIQUELY_SILLY_TEXT)@"
 };
 char line[4096];
 int i;

 if(askme->level_info!=NULL)
   Askme_id(askme,0);
 fprintf(stdout,"\n"); 
 fprintf(stdout,"Anwendung: %s Quellfile [Optionen|Filenamen]\n",
         askme->progname); 
 fprintf(stdout,"\n"); 
 for(i=0;
     strcmp(text[i],"@ENDE_OF_HELPTEXT_(HOPEFULLY_UNIQUELY_SILLY_TEXT)@")!=0;
     i++)
   fprintf(stdout,"%s\n",text[i]);
 fprintf(stdout,"\n"); 
 fprintf(stdout,"Beispiele (suche eiche.jpg auf allen Backup Levels) :\n");
 fprintf(stdout,"  %s /cdrom/ASKME -levelall /home/bilder/baeume/eiche.jpg\n",
                askme->progname);
 fprintf(stdout,"  %s /cdrom/ASKME -levelall -search_shpat '*baeume/eiche*'\n",
                askme->progname);
 return(1);
}


int Askme_interpreter(askme,in_cmd,flag)
struct AskmE *askme;
char *in_cmd;
int flag;
/*
return:
 <=0 error , 1 = success , 2 = nothing found , 3 = end program run
*/
{
 int ret,volno= -1,no_sublevels= 0,i;
 char cmd[2*4096];
 
 if(askme==NULL)
   return(0);
 strcpy(cmd,in_cmd);

 if(strcmp(cmd,"-end")==0) {
   return(3);
 } else if(strcmp(cmd,"-help")==0) {
   Askme_help(askme,0);
   no_sublevels= 1;
 } else if(strcmp(cmd,"-hilfe")==0) {
   Askme_hilfe(askme,0);
   no_sublevels= 1;
 } else if(strcmp(cmd,"-id")==0) {
   Askme_id(askme,0);
   if(!askme->levelall)
     no_sublevels= 1;
 } else if(strcmp(cmd,"-count")==0) {
   fprintf(stdout,"%ld\n",askme->num_volumes);
   if(!askme->levelall)
     no_sublevels= 1;
 } else if(strncmp(cmd,"-list",5)==0 && cmd[5]!='_') {
   if(cmd[5]!=0) {
     volno= -1;
     sscanf(cmd+6,"%ld",&volno);
     if(volno<=0 || volno>askme->num_volumes)
       volno= -1;
   }
   ret= Askme_list(askme,volno,0);
   if(ret<=0)
     return(ret);
   if(askme->levelall && volno<=0)
     if(askme->sublevels!=NULL)
       for(i=askme->num_sublevels-1;i>=0;i--) {
         fprintf(stdout,
                 "\n\n--------------------------------------------------\n\n");
         Askme_id(askme->sublevels[i],0);
         ret= Askme_list(askme->sublevels[i],-1,0);
         if(ret<=0)
           return(ret);
       }
   no_sublevels= 1;
 } else if(strcmp(cmd,"-levelall")==0) {
   askme->levelall= 1;
   no_sublevels= 1;
 } else if(strcmp(cmd,"-nolevel")==0) {
   askme->nolevel= 1;
 } else if(strcmp(cmd,"-level_reset")==0) {
   askme->levelall= 0;
   askme->nolevel= 0;
   no_sublevels= 1;
 } else if(strcmp(cmd,"-suball")==0) {
   askme->sub= 1;
   askme->suball= 1;
   Askme_interpreter(askme,"-levelall",0);
 } else if(strcmp(cmd,"-fast")==0) {
   askme->sub= 0;
 } else if(strcmp(cmd,"-sub_reset")==0) {
   askme->sub= 1;
   askme->suball= 0;
 } else if(strcmp(cmd,"-dialog")==0) {
   askme->dialog= 1;
 } else if(strcmp(cmd,"-dialog_reset")==0) {
   askme->dialog= 0;
 } else if(strcmp(cmd,"-search_reset")==0) {
   askme->search_mode= 0;
 } else if(strcmp(cmd,"-search_fgrep")==0) {
   askme->search_mode= 1;

#ifdef Askme_with_regeX
 } else if(strcmp(cmd,"-search_grep")==0) {
   askme->search_mode= 2;
 } else if(strcmp(cmd,"-search_shpat")==0) {
   askme->search_mode= 3;
#endif /* Askme_with_regeX */

 } else if(strncmp(cmd,"-prog",5)==0 && cmd[5]!='_' && cmd[5]!=0) {
   strcpy(askme->progname,cmd+6);
 } else {
   ret= Askme_search_file(askme,cmd,-1,0);
   if(ret<0)
     return(ret);
   if(ret==0)
     return(2);
   no_sublevels= 1;
 }
 if(!no_sublevels)
   if(askme->sublevels!=NULL)
     for(i=0;i<askme->num_sublevels;i++)
       Askme_interpreter(askme->sublevels[i],cmd,flag);
 return(1);
}


int Askme_dialog(askme,flag)
struct AskmE *askme;
int flag;
{
 int ret;
 char line[2*4096];

 while(1) {
   fprintf(stderr,"enter option or filename :\n");
   if(Sfile_fgets(line,sizeof(line)-1,stdin)==NULL) 
 break;
   fprintf(stderr,
           "==============================================================\n");
   ret= Askme_interpreter(askme,line,0);
   if(ret<0)
     return(ret);
   if(ret==3)
 break;
 }
 return(1);
}


#ifdef Askme_with_maiN

main(argc,argv)
int argc;
char **argv;
{
 int ret,i,search_failed,found;
 struct AskmE *askme= NULL;
 
 if(argc<2) {
   fprintf(stderr,"usage : %s sourcefile|-help [options|filenames]\n",
           argv[0]);
   exit(2);
 }
 ret= Askme_new(&askme,argv[0],argv[1],0);
 if(ret<=0) {
   fprintf(stderr,"Creation of AskmE object failed. (not enough memory ?)\n");
   exit(3);
 }
 i= 1;
 if(strncmp(argv[1],"-prog_help",10)==0 && argv[1][10]!='_'
    && argv[1][10]!=0) {
   strcpy(askme->progname,argv[1]+11);
   goto help;
 }
 if(strcmp(argv[1],"-help")==0) {
help:;
   Askme_help(askme,0);
   exit(0);
 }
 if(strncmp(argv[1],"-prog_hilfe",11)==0 && argv[1][11]!='_'
    && argv[1][11]!=0) {
   strcpy(askme->progname,argv[1]+12);
   goto hilfe;
 }
 if(strcmp(argv[1],"-hilfe")==0) {
hilfe:;
   Askme_hilfe(askme,0);
   exit(0);
 }
 ret= Askme_read_all(askme,0);
 if(ret<=0) {
   fprintf(stderr,"Could not read given file and its possible sublevels.\n");
   fprintf(stderr,"filename=%s\n",argv[1]);
   if(errno>0)
     perror("last error encountered");
   exit(4);
 }
 for(i=2;i<argc;i++) {
   ret= Askme_interpreter(askme,argv[i],0);
   if(ret<=0)
     exit(5);
   if(ret==3)
     goto end_sucessfully;
   
 }
 if(askme->dialog) {
   ret= Askme_dialog(askme,0);
   if(ret<=0)
     exit(6);
 }
end_sucessfully:;
 found= askme->found;
 search_failed= askme->search_failed;
 Askme_destroy(&askme,0);
 exit(search_failed>0 && found<=0);
}

#endif /* Askme_with_maiN */

