
/*
  cc -g -static -o raedchen raedchen.c
*/

/* Das ist eigentlich die Version von  cd_backup_planer.c  */
#define PROG_VERSION "0.8"

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <signal.h>


static int abort_run= 0;

void Cleanup_handler_pipe()
{
 abort_run= 1;
 return;
}


double Scanf_io_size(text,flag)
char *text;
int flag;
{
 int c;
 double wert;

 if(text[0]==0)
   return(0.0);
 sscanf(text,"%lf",&wert);
 if(wert>=1) {
   c= text[strlen(text)-1];
   if(c=='k' || c=='K') wert*= 1024.0;
   if(c=='m' || c=='M') wert*= 1024.0*1024.0;
   if(c=='g' || c=='G') wert*= 1024.0*1024.0*1024.0;
 }
 return(wert);
}

int Pipe_close(zielfp,command,flag)
FILE *zielfp;
char *command;
int flag;
{
 fflush(zielfp);
 pclose(zielfp);
 if(command[0]!=0)
   system(command);
 return(1);
}


int Sfile_scale(value,result,siz,thresh,flag)
double value;
char *result;
int siz;
double thresh;
int flag;
/*
 bit0= eventually ommit 'b'
 bit1= make text as short as possible
 bit2= no fraction (if it would fit at all)
*/
{
 char scale_c,scales[6],form[80];
 int i,dec_siz= 0,avail_siz;

 strcpy(scales,"bkmgt");
 scale_c= scales[0];
 for(i=1;scales[i]!=0;i++) {
   if(value<thresh) 
 break;
   value/= 1024;
   scale_c= scales[i];
 } 
 if(scale_c!='b' && !(flag&4)) { /* is there room for fractional part ? */
   avail_siz= siz-1;
   sprintf(form,"%%.lf");
   sprintf(result,"%.lf",value);
   if(strlen(result)<avail_siz-2) 
     dec_siz= 1;                                  /* we are very modest */
 }
 if(scale_c=='b' && (flag&1)) {
   if(flag&2)
     sprintf(form,"%%.lf");
   else
     sprintf(form,"%%%ld.lf",siz);
   sprintf(result,form,value);
 } else {
   if(flag&2)
     sprintf(form,"%%.lf%%c");
   else if(dec_siz>0) 
     sprintf(form,"%%%ld.%ldlf%%c",avail_siz,dec_siz);
   else
     sprintf(form,"%%%ld.lf%%c",siz-1);
   sprintf(result,form,value,scale_c);
 }
 return(1);
}


main(argc,argv)
int argc;
char **argv;
{
 static char raedchen[]= {"|/-\\"};
 static char post_text[4096]={"bytes"};
 static char pipe_text[4096]={""};
 static char post_pipe_text[4096]={""};
 static char read_file[4096]={""};
 static char prompt_text[4096]={"Prepare next piece and press ENTER"};
 static double pipe_stueck_gr= 1.0e99;
 static FILE *zielfp;
 static FILE *readfp;
 static int quiet= 0;
 char buffer[4096],inp[321],num[81];
 double zaehler= 0.0,pipe_zaehler= 0.0;
 int pipe_command_not_started= 1,compact_num= -1;
 int i,radpos=0,drehrest=0,dreh=64*1024,c,ret= 0,bufgr,gelesen,no_epipe= 0;
 int zahlzeigen=1, cursor_home=0, schlucken=0, einzel_char=0, schlusszahl=0;
 int pad_size= 0;
 FILE *fpin;

 bufgr= sizeof(buffer);
 zielfp= stdout;
 readfp= stdin;

 for(i=1;i<argc;i++){
   if(strcmp(argv[i],"-count")==0) {
     zahlzeigen= 1;
   } else if(strcmp(argv[i],"-no_count")==0) {
     zahlzeigen= 0;
   } else if(strcmp(argv[i],"-print_count")==0) {
     schlusszahl= 2;
   } else if(strcmp(argv[i],"-print_count_off")==0) {
     schlusszahl= 0;
   } else if(strcmp(argv[i],"-print_count_stdout")==0) {
     schlusszahl= 1;
   } else if(strcmp(argv[i],"-cursor_home")==0) {
     cursor_home= 1;
   }else if(strcmp(argv[i],"-cursor_end")==0) {
     cursor_home= 0;
   }else if(strcmp(argv[i],"-output")==0) {
     schlucken= 0;
   }else if(strcmp(argv[i],"-no_output")==0) {
     schlucken= 1;
   }else if(strcmp(argv[i],"-epipe")==0) {
     no_epipe= 0;
   }else if(strcmp(argv[i],"-compact_num")==0) {
     compact_num= 1;
   }else if(strcmp(argv[i],"-no_compact_num")==0) {
     compact_num= 0;
   }else if(strcmp(argv[i],"-no_epipe")==0) {
     no_epipe= 1;
   }else if(strcmp(argv[i],"-step")==0 && i+1<argc) {
     i++;
     dreh= Scanf_io_size(argv[i],0);
     if(dreh<=0) dreh= 1;
     if(dreh<bufgr) einzel_char= 1;
     else           einzel_char= 0;
   }else if(strcmp(argv[i],"-post_text")==0 && i+1<argc) {
     i++;
     strcpy(post_text,argv[i]);
   }else if(strcmp(argv[i],"-pipe")==0 && i+3<argc) {
     i++;
     strcpy(read_file,argv[i]);
     if(read_file[0]=='-' && read_file[1]==0)
       read_file[0]= 0;
     i++;
     pipe_stueck_gr= Scanf_io_size(argv[i],0);
     i++;
     strcpy(pipe_text,argv[i]);
   }else if(strcmp(argv[i],"-post_pipe_command")==0 && i+1<argc) {
     i++;
     strcpy(post_pipe_text,argv[i]);
   }else if(strcmp(argv[i],"-prompt")==0 && i+1<argc) {
     i++;
     strcpy(prompt_text,argv[i]);
   }else if(strcmp(argv[i],"-quiet")==0) {
     quiet= 1;
   }else if(strcmp(argv[i],"-loud")==0) {
     quiet= 0;
   }else if(strcmp(argv[i],"-pad")==0 && i+1<argc) {
     i++;
     pad_size= Scanf_io_size(argv[i],0);
     if(pad_size<0) pad_size= 0;
     if(pad_size<bufgr) einzel_char= 1;
     else               einzel_char= 0;
   }else if(strcmp(argv[i],"-help")==0) {
     ret= 0;
     goto usage_text;
   }else {
     fprintf(stderr,"%s : unknown option\n",argv[i]);
     ret= 1;
usage_text:;
     fprintf(stderr,"usage : %s\n",argv[0]);
     fprintf(stderr,
             "           -count | -no_count | -cursor_home | -cursor_end |\n");
     fprintf(stderr,
             "           -output | -no_output | -step number |\n");
     fprintf(stderr,
             "           -print_count | -print_count_stdout |\n");
     fprintf(stderr,
             "           -print_count_off | -post_text text |\n");
     fprintf(stderr,
             "           -pipe source size command | -prompt text |\n");
     fprintf(stderr,
             "           -post_pipe_command command | -quiet | -loud\n");
     fprintf(stderr,
             "           -epipe | -no_epipe | -pad size\n");
     fprintf(stderr,"\n");
     fprintf(stderr,"This program entertains the user while copying\n");
     fprintf(stderr,"standard input to standard output. It usually shows a\n");
     fprintf(stderr,"spinning bar and the byte count.\n");
     fprintf(stderr,"-quiet prevents the output of entertaining messages.\n");
     fprintf(stderr,"-loud (which is the default) enables this output.\n");
     fprintf(stderr,"-no_count prevents showing the byte count.\n");
     fprintf(stderr,"-no_output is equal to >/dev/null but 30 %% faster.\n");
     fprintf(stderr,"-step adjusts the count interval.\n");
     fprintf(stderr,"(Default is -step 64k, try -step 100000 or -step 1m )\n");
     fprintf(stderr,"-compact_num enables byte count texts like 105.3m\n");
     fprintf(stderr,"(This is the default if -step is at least 1024).\n");
     fprintf(stderr,"-no_compact_num prints flat bytecounts like 110415052.\n");
     fprintf(stderr,"-print_count_off leaves no visible text after exit.\n");
     fprintf(stderr,"-print_count prints the final count on standard error.\n");
     fprintf(stderr,"-print_count_stdout prints this on standard output.\n");
     fprintf(stderr,"-post_text defines the text to be shown after the\n");
     fprintf(stderr,"bytecount. (default is -post_text 'bytes' )\n");
     fprintf(stderr,"\n");
     fprintf(stderr,"A second purpose of this program is to cut the data\n");
     fprintf(stderr,"stream into pieces and to feed them into the\n");
     fprintf(stderr,"standard input of a shell command. This command is\n");
     fprintf(stderr,"executed at the start of each piece and should end\n");
     fprintf(stderr,"properly on EOF at standard input.\n");
     fprintf(stderr,"Between the pieces, the user is prompted to prepare\n");
     fprintf(stderr,"the next one (e.g. insert next CD)\n");
     fprintf(stderr,"-pipe divides the output into pieces of at most\n");
     fprintf(stderr,"'number' size. Each piece is piped into the standard\n");
     fprintf(stderr,"input of a newly started instance of 'command'.\n");
     fprintf(stderr,"The command is only started after at least one byte of\n");
     fprintf(stderr,"input arrived for the piece.\n");
     fprintf(stderr,"If 'source' is '-' the standard input is read. Any\n");
     fprintf(stderr,"other text is used as name of a file which is opened\n");
     fprintf(stderr,"at the start of each piece and closed after its end.\n");
     fprintf(stderr,"This is suitable for device files. Data files should\n");
     fprintf(stderr,"be read by piping them into standard input.\n");
     fprintf(stderr,"-prompt defines the text to be asked between the\n");
     fprintf(stderr,"pieces. default: 'Prepare next piece and press ENTER'\n");
     fprintf(stderr,"-post_pipe_command defines a shell command which is\n");
     fprintf(stderr,"executed when a -pipe piece is closed and the -pipe\n");
     fprintf(stderr,"command has ended.\n");
     fprintf(stderr,"-no_epipe disables the error message if the pipe gets\n");
     fprintf(stderr,"closed by the receiver of output. (-epipe enables)\n");
     fprintf(stderr,"\n");
     fprintf(stderr,"-pad writes a trailing piece of data of the given\n");
     fprintf(stderr,"size. This also happens at the end of any -pipe piece.\n");
     fprintf(stderr,".\n");
     exit(ret);
   }
 }

 signal(SIGPIPE,Cleanup_handler_pipe);

 if(read_file[0]!=0){
   readfp= fopen(read_file,"r");
   if(readfp==NULL) return(1);
 }
 if(compact_num==-1 && dreh<1024) 
   compact_num= 0;
 while(!abort_run) {
   if(einzel_char){
lies_einzeln:;
     if((c= fgetc(readfp))==EOF) 
 break;
     gelesen= 1;
     drehrest++;
     pipe_zaehler++;
   }else{
     if(pipe_zaehler+dreh>pipe_stueck_gr){
       einzel_char= 1;
       goto lies_einzeln;
     } 
     gelesen= fread(buffer,1,bufgr,readfp);
     if(gelesen==0) 
 break;
     drehrest+= gelesen;
     pipe_zaehler+= gelesen;
   }

   if(pipe_command_not_started) {
     if(pipe_text[0]!=0){
       zielfp= popen(pipe_text,"w");
       if(zielfp==NULL)
         return(1);
     }
     pipe_command_not_started= 0;
   }

   while(drehrest>=dreh) {
     zaehler+= dreh;
     drehrest-= dreh;
     if(!quiet){
       if(zahlzeigen) {
         if(compact_num) {
           Sfile_scale(zaehler,num,7,1e5,1);
         } else {
           sprintf(num,"%12.lf",zaehler);
         }
         fprintf(stderr,"\r%c  %s %s ",raedchen[radpos],num,post_text);
       } else
         fprintf(stderr,"\r%c  ",raedchen[radpos]);
       if(cursor_home)
         fprintf(stderr,"\r");
     }
     radpos++;
     if(radpos>=4) radpos= 0;
   }
   if(!schlucken){
     if(einzel_char){
       if(fputc(c,zielfp)==EOF) {
         perror(argv[0]);
         ret= 1;
 break;
       }
     }else{
       if(fwrite(buffer,1,gelesen,zielfp)!=gelesen){
         if(errno!=EPIPE || no_epipe==0)
           perror(argv[0]);
         ret= 1;
 break;
       }
     }
   }
   if(pipe_text[0]!=0 && pipe_zaehler>=pipe_stueck_gr){
     if(read_file[0]!=0){
       if(readfp!=stdin) fclose(readfp);
     }

     if(zielfp!=NULL) {
       for(i=0; i<pad_size; i++) {
         if(fputc(raedchen[i%4],zielfp)==EOF) {
           perror(argv[0]);
           ret= 1;
 break;
         }
       }
     }

     Pipe_close(zielfp,post_pipe_text,0);
     pipe_command_not_started= 1;

     fprintf(stderr,"\n");
     for(i=0;i<strlen(prompt_text); i++) fprintf(stderr,"-");
     fprintf(stderr,"\n");
     fprintf(stderr,"%s\n",prompt_text);
     for(i=0;i<strlen(prompt_text); i++) fprintf(stderr,"-");
     fprintf(stderr,"\n");
     fpin= fopen("/dev/tty","r");
     fgets(inp,sizeof(inp),fpin);
     fclose(fpin);
     fprintf(stderr,"... continuing ...\n");

     if(read_file[0]!=0){
       readfp= fopen(read_file,"r");
       if(readfp==NULL) return(1);
     }
/*
     zielfp= popen(pipe_text,"w");
     if(zielfp==NULL) return(1);
*/
     pipe_zaehler= 0;
     if(dreh<bufgr) einzel_char= 1;
     else           einzel_char= 0;
   } 
 }

ex:; 

 if(ret==0 && zielfp!=NULL) {
   for(i=0; i<pad_size; i++) {
     if(fputc(raedchen[i%4],zielfp)==EOF) {
       perror(argv[0]);
       ret= 1;
   break;
     }
   }
 }

 if(pipe_text[0]!=0)
   Pipe_close(zielfp,post_pipe_text,0);
 
 if(!quiet)
   fprintf(stderr,"\r                                                                           \r");
 if(compact_num) {
   Sfile_scale(zaehler+drehrest,num,7,1e5,1);
 } else {
   sprintf(num,"%12.lf",zaehler+drehrest);
 }
 if(schlusszahl==1){
   fprintf(stdout,"%s %s\n",num,post_text);
 }else if(schlusszahl==2) {
   fprintf(stderr,"\r   %s %s\n",num,post_text);
 }
 exit(ret);
}

